// http://lodev.org/cgtutor/sierpinski.html

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
 screen_width = 256;
 screen_height = 256;


implementation

{$R *.dfm}



procedure TForm1.Button1Click(Sender: TObject);
// TRIANGLE
var x,y: integer;
    bmp: TBitmap;
begin

 bmp:=TBitmap.Create;
 bmp.PixelFormat:=pf24bit;
 bmp.Width:=screen_width;
 bmp.Height:=screen_height;

 for  y := 0 to screen_height - 1 do
  for x := 0 to screen_width - 1 do begin

   if x and y=0 then
    bmp.Canvas.Pixels[x,y]:=clWhite
   else
    bmp.Canvas.Pixels[x,y]:=clBlack;

  end;

 form1.Image1.Picture.Graphic := bmp;

 bmp.Free;

end;


procedure TForm1.Button2Click(Sender: TObject);
// CARPET
var x,y: integer;
    bmp: TBitmap;
begin

 bmp:=TBitmap.Create;
 bmp.PixelFormat:=pf24bit;
 bmp.Width:=screen_width;
 bmp.Height:=screen_height;

 for  y := 0 to screen_height - 1 do
  for x := 0 to screen_width - 1 do begin

        if
            //Not both the first (rightmost) digits are '1' in base 3
            not( ((x mod 3)=1) and ((y mod 3)=1) )

            and

            //Not both the second digits are '1' in base 3
            not( ((x div 3) mod 3=1) and ((y div 3) mod 3=1) )

            and

            //Not both the third digits are '1' in base 3
            not( ((x div 9) mod 3=1) and ((y div 9) mod 3=1) )

           and

            //Not both the fourth digits are '1' in base 3
            not( ((x div 27) mod 3=1) and ((y div 27) mod 3=1) )

            and

            //Not both the fourth digits are '1' in base 3
            not( ((x div 81) mod 3=1) and ((y div 81) mod 3=1) ) then

             bmp.Canvas.Pixels[x,y] := clWhite
            else
             bmp.Canvas.Pixels[x,y] := clBlack;

  end;

 form1.Image1.Picture.Graphic := bmp;

 bmp.Free;

end;


end.
